#ifndef _bisq_Fb_h
#define _bisq_Fb_h

#include <rfftw.h>
#include <time.h>

extern int COL, LINE;

enum fb_req_type {fb_not_required=0, fb_is_required};

typedef struct Viewer
{
	enum fb_req_type fb_required;
	int fb_refresh_self; /* not meaningful when fb not required */
	void (*Init)(void);
	void (*Done)(void);
	void (*View)(void);
} Viewer;

#ifdef __cplusplus
extern "C" {
#endif

extern void fb_done(void);
extern void fb_init(Viewer *viewer);
extern void fb_center(int y, char *s);
extern void fb_view(time_t *Begin, time_t *Now);
extern void fb_writepalette(void);

#ifdef __cplusplus
}
#endif

/* For viewers */
extern unsigned char Palette[256*3];
extern unsigned char *Vid;
extern float FPS;
extern int fb_fh; /* Framebuffer filehandle */
extern fftw_real Avg[N/2+1], AvgCount;

extern int FontHeight;
extern unsigned char *FontData;

/* If zero, must not interfere the screen. */
/* If was zero and became nonzero,   *
 * must refresh the screen contents. */
extern int Active;

#endif
